##FAKE CONFIG FILE TO MAKE COMPATABILITY BETWEEN CANVAS AND STANDALONE MOSDEF AS EASY AS POSSIBLE 

from types import DictType
import re

ConfigFileSeparator = '='

class _CanvasConfig(DictType):
    
    __default_config = """
    cparse_version="2"
    """

    def __init__(self, argv = None):
        DictType.clear(self)
        
        # first of all we load default CANVAS config (at the top of that file)
        for line in self.__default_config.split('\n'):
            self.__parse_configline(line, 'Config::DefaultConf')
        
    
    def __setitem__(self, name, val):
        if type(val) == type("") and val.lower() in ['no', 'false']:
            val = False
        DictType.__setitem__(self, name, val)
    
    
    def __parse_configline(self, line, devloglevel = 'Config::parse_configline'):

        comment_type_table = {'#': "DESC", ';': "COMMENTED"}
        line = line.strip()
        if re.match('^\s*$', line):
            return
        if re.match('^\s*(#|;)', line):
            ignored, comment_type, comment = re.split('^\s*(#|;)\s*', line)
            return
        val = True
        seppos = line.find(ConfigFileSeparator)
        if seppos != -1:
            name = line[:seppos].strip()
            val = line[seppos+1:].strip()
        else:
            name = line
        self.__setitem__(name, val)
    
    
    def __getitem__(self, *kargs):
        value = False
        name = kargs[0]
        if type(name) == type(()):
            name, value = name[:2]
        if DictType.__contains__(self, name):
            value = DictType.__getitem__(self, name)
        return value
    
    def __str__(self):
        return "<CANVAS Config instance %s>" % DictType.__repr__(self)
    
global CanvasConfig
CanvasConfig = _CanvasConfig()
